Summary: User-Mode Linux is a safe, secure way of running Linux versions and Linux processes.
Name: user-mode-linux

### zurukko.
%global _unpackaged_files_terminate_build 0

### Version defines
%global momorel 1
%global rel %{momorel}m
#%%global rcver 4
#%%global rel 0.%{rcver}.%{momorel}m

## http://www.kernel.org/
%global srcversion 2.6.10
%global rpmversion 2.6.10
#%%global kversion   %{rpmversion}-rc%{rcver}
%global kversion   %{rpmversion}

## [usagi] ftp://ftp.linux-ipv6.org/pub/usagi/daily-snap/
## ex. /200411/linux26-2.6.9-usagi-20041102.patch.gz
##     (month)         (base)     (month+day)==usagisnapver
%global usagisnapver_month 200412
%global usagisnapver_day   30
%global usagibase          2.6.10
%global usagisnapver       %{usagisnapver_month}%{usagisnapver_day}
%global usagiuri ftp://ftp.linux-ipv6.org/pub/usagi/daily-snap/
%global usagipatchname linux26-%{usagibase}-usagi-%{usagisnapver}.patch.gz
#%%global usagi_ipv6 1 is set below

## [kdb] http://oss.sgi.com/projects/kdb/
%global kdb_ver v4.4
%global kdb_kernel_ver 2.6.10

## [mkinitrd]
%global mkinitrd_ver 3.4.43-10m

## [module-init-tools]
%global module_init_tools_ver 3.0-1m


### Constant defines
%global fileprefix kernel
%global KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}

## Configuration
%global verbose_make 1
%global kdb          0
%global usagi_ipv6   1

### Constant Headers
Group: Applications/System
License: GPL
BuildPreReq: sed autoconf texinfo sharutils
BuildPreReq: unzip
BuildPreReq: module-init-tools
BuildRequires: momonga-rpmmacros >= 20040310-4m
BuildRequires: rpm >= 4.0.4-53m
ExclusiveArch: %{ix86}
ExclusiveOS: Linux
Autoreqprov: no
Prereq: sh-utils, fileutils, tar, gzip, module-init-tools >= %{module_init_tools_ver}, mkinitrd >= %{mkinitrd_ver}

### Define-dependent headers
Version: %{rpmversion}
Release: %{rel}
URL: http://user-mode-linux.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%ifarch ppc
%global buildcc gcc_2_95_3
BuildRequires: gcc2.95.3
%else
%global buildcc gcc
BuildRequires: gcc
%endif

############################################################
############# Source #######################################
############################################################
## >>source <-- use to search in emacs

%global md5src0 cffcd2919d9c8ef793ce1ac07a440eda
%NoSource 0 ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-%{srcversion}.tar.bz2 %{md5src0}

Source20: config-uml

###################################################################
# Patch Section ###################################################
###################################################################
# >>patches

#
# Patches 0 through 100 are meant for core subsystem upgrades
#

##%%NoPatch 0 http://www.kernel.org/pub/linux/kernel/v2.6/testing/patch-%{kversion}.bz2 17f198c9f9b912b46ccf9b9f7b5137c5
# %%NoPatch 1 ftp://ftp.kernel.org/pub/linux/kernel/people/akpm/patches/2.6/2.6.9-rc2/2.6.9-rc2-mm3/2.6.9-rc2-mm3.bz2 ff5e23cb277f1288a2993c61d9f052a6

## ipv6 subsystem update
%global md5patch50 639d7eee9312abe8539f7eea4b3fb1fb
%NoPatch 50 %{usagiuri}/%{usagisnapver_month}/%{usagipatchname} %{md5patch50}

Patch51: linux-2.6.0-for-usagi.patch

# kdb
%NoPatch 70 ftp://oss.sgi.com/www/projects/kdb/download/%{kdb_ver}/kdb-%{kdb_ver}-%{kdb_kernel_ver}-common-1.bz2 9030aa26d75bf9f19db90448b6425d7b
%NoPatch 71 ftp://oss.sgi.com/www/projects/kdb/download/%{kdb_ver}/kdb-%{kdb_ver}-%{kdb_kernel_ver}-i386-1.bz2 c505871f2b3f6dea19f4d63a8fc2f956
%NoPatch 72 ftp://oss.sgi.com/www/projects/kdb/download/%{kdb_ver}/kdb-%{kdb_ver}-%{kdb_kernel_ver}-ia64-1.bz2 24e59800d840d2dd7af89aff2599760d

#
# Patches 500 through 999 are reserved for bugfixes to the core system
# and patches related to how RPMs are build
#

Patch500: linux-2.6.10-nonintconfig.patch
#Patch530: linux-2.6.10-dbus.patch
Patch531: linux-2.6.10-dbus-smp.patch
# Patch540: linux-2.6.6-online-resize.patch
# Patch550: kernel2.6.8.1-kcalloc.patch
Patch560: linux-2.6.8.1-crc-ccitt.patch

# Patch570: For compilation of NVIDIA driver (ver 1.0-6111)
#   http://www.uwsg.indiana.edu/hypermail/linux/kernel/0410.2/0753.html
%NoPatch 570 http://ck.kolivas.org/patches/2.6/2.6.9/2.6.9-ck1/patches/nvidia_compat.diff e391697899c02b63bcf8cc550fc6a539

Patch580: 2.6.10-mm1-brk-locked.patch

###

Patch700: http://www.polbox.com/h/hs001/linux-2.6.10-mppe-mppc-1.2.patch.gz
NoPatch: 700

#
# Patches 1000 to 1999 are reserved for bugfixes to drivers and filesystems
#

Patch1000: linux-2.6.0-test11-vidfail.patch
# Patch1030: linux-2.6.8.1-ext3-reservations.patch
# Patch1031: linux-2.6.8-ext3-reservations-update.patch
# Patch1130: linux-2.6.7-i8x0-drm.patch
# Patch1140: linux-2.6.8.1-usb2-storage.patch

%global  md5patch1001 4490d1be6855403a267ead075e626980
%global sha1patch1001 6cbbd2fc16268c9bb770f8bdf68f352bc9d74d60
%NoPatch 1001 http://ftp.namesys.com/pub/reiser4-for-2.6/2.6.10/reiser4-for-2.6.10-1.gz %{md5patch1001}
Patch1002: reiser4-export-find_get_pages_tag.patch

# Patch numbers from 2000 to 3000 is for the stuff that has to come 
# last due to the amount of drivers they touch. 
# Only such type of patches should go here.
# Not for the patches you're too lazy to put in the proper place.
#

#Patch2000: ftp://ftp.kernel.org/pub/linux/kernel/people/akpm/patches/2.6/2.6.9-rc1/2.6.9-rc1-mm3/broken-out/scsi-qla2xxx-fix-inline-compile-errors.patch
Patch2001: linux-2.6.9-rc3-megaraid-gcc34.patch

Patch2002: scx200-undefine.patch
# Patch2006: ieee80211_module-fix.patch

#
#  end of patch
#

%description
User-Mode Linux is a safe, secure way of running Linux versions
and Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux,
all without risking your main Linux setup.

User-Mode Linux gives you a virtual machine that may have more hardware
and software virtual resources than your actual, physical computer.
Disk storage for the virtual machine is entirely contained inside a single
file on your physical machine. You can assign your virtual machine only
the hardware access you want it to have. With properly limited access,
nothing you do on the virtual machine can change or damage your real computer,
or its software.

#############################################################
##### PREP ##################################################
#############################################################
# >>prep

%prep

%setup -q -n linux-%{kversion}

# rc patch
##%%patch0 -p1

%patch1001 -p1
%patch1002 -p1

##########
########## Patch application starts
##########

#
# Patches 0 through 100 are meant for core subsystem upgrades
# 

# ipv6 subsystem update
%if %{usagi_ipv6}
%patch50 -p1
cd net/ipv6
%patch51
cd -
%endif

# kdb
%if %{kdb}
%patch70 -p1
%patch71 -p1
%patch72 -p1
%endif

#
# Patches 500 through 1000 are reserved for bugfixes to the core system
# and patches related to how RPMs are build
#

# This patch adds a "make oldconfig_nonint" which is non-interactive and
# also gives a list of missing options at the end. Useful for automated
# builds (as used in the Red Hat buildsystem).
%patch500 -p1

#
# make the kernel spit out DBUS notifications over netlink
#
%patch531 -p1

#
# EXT3 online resize patch (experimental)
#
# %%patch540 -p1

#
# kcalloc
#
# %patch550 -p1

#
# source header patch for crc-ccitt.h
#
%patch560 -p1

#
# patch for compilation of NVIDIA driver
#
%patch570 -p1

# security fix patches
%patch580 -p1

%patch700 -p1

#
# Patches 1000 to 5000 are reserved for bugfixes to drivers and filesystems
#

# add vidfail capability;
# without this patch specifying a framebuffer on the kernel prompt would
# make the boot stop if there's no supported framebuffer device; this is bad
# for the installer cd that wants to automatically fall back to textmode
# in that case
%patch1000 -p1

#                         
# Ext3 reservations. reduces fragmentation bigtime
#
# %%patch1030 -p1
# %%patch1031 -p1

#                         
# i810/i830 DRM performance improvement/bugfix
#
# %%patch1130 -p1

#
# for USB storage (USB 2.0?)
#
# %%patch1140 -p1

#
# Patches 5000 to 6000 are reserved for new drivers
#

#
# final stuff
#

#
# misc small stuff to make things compile or otherwise improve performance
#

# %%patch2000 -p1
%patch2001 -p1

#for scx200
# WARNING: /lib/modules/2.6.9-0.3.3m/kernel/drivers/mtd/maps/scx200_docflash.ko
#  needs unknown symbol del_mtd_partitions
# WARNING: /lib/modules/2.6.9-0.3.3m/kernel/drivers/mtd/maps/scx200_docflash.ko
#  needs unknown symbol add_mtd_partitions

%patch2002 -p1

#
# Add MODULE_LICENSE() where it's missing
#

# END OF PATCH APPLICATIONS

sed -e "s!gcc!%{buildcc}!" Makefile > Makefile.cc
mv Makefile.cc Makefile

#backup and copy using defconfig file
mv arch/um/defconfig arch/um/defconfig.origin
cp %{SOURCE20} arch/um/defconfig

##delete inline and __inline__ for gcc34
#cd drivers/scsi/qla2xxx
#for i in *;do
#  sed -e 's,inline void, void,g' $i > $i.$$
#  sed -e 's,inline int, int,g' $i.$$ > $i.$$.$$
#  sed -e 's,__inline__,,g' $i.$$.$$ > $i
#done
#cd -
#cd drivers/scsi/megaraid
#for i in *;do
#  sed -e 's,inline void, void,g' $i > $i.$$
#  sed -e 's,inline int, int,g' $i.$$ > $i.$$.$$
#  sed -e 's,__inline__,,g' $i.$$.$$ > $i
#done
#cd -

find . -name "*.orig" -o -name "*~" -exec rm -fv {} \;
find . -name CVS | xargs rm -rf

#############################################
######### build #############################
#############################################
### >>build

%build

echo DISTCC_HOSTS=\"$DISTCC_HOSTS\"

# make sure EXTRAVERSION says what we want it to say
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$1/" Makefile

make mrproper ARCH=um
cp %{SOURCE20} .config

make nonint_oldconfig ARCH=um > /dev/null
make include/linux/version.h 

make %{?_smp_mflags} vmlinux ARCH=um V=%{verbose_make} \
  || make vmlinux ARCH=um V=%{verbose_make}
#make %{?_smp_mflags} modules ARCH=um V=%{verbose_make} \
#  || make modules ARCH=um V=%{verbose_make}
 
%install
rm -rf %{buildroot}
#make INSTALL_MOD_PATH=%{buildroot} modules_install ARCH=um

mkdir -p %{buildroot}%{_bindir}
install -m 755 vmlinux %{buildroot}%{_bindir}/linux-%{version}-%{release}

mkdir -p %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include
for i in acpi asm-um asm-generic linux math-emu media net pcmcia rxrpc scsi sound video; do
  cp -a include/$i %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include
done
ln -s asm-um %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include/asm
%ifarch %{ix86}
cp -a include/asm-i386 %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include
%endif
%ifarch alpha alphaev5
cp -a include/asm-alpha %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include
%endif
%ifarch ppc
cp -a include/asm-ppc %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include
cp -a include/asm-m68k %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}um/include
%endif

mkdir -p %{buildroot}%{_libdir}/uml-%{version}-%{release}
cd %{buildroot}
#tar --owner=0 --group=0 -czf \
#	%{buildroot}%{_libdir}/uml-%{version}-%{release}/modules.tar.gz \
#	lib/modules/*.*.*-*um
tar --owner=0 --group=0 -czf \
	%{buildroot}%{_libdir}/uml-%{version}-%{release}/headers.tar.gz \
	usr/src/*
cd -

# remove
rm -rf %{buildroot}/lib
rm -rf %{buildroot}/usr/src

%clean
rm -rf %{buildroot}

%post 
rm -f %{_bindir}/linux
ln -s linux-%{version}-%{release} %{_bindir}/linux

%preun
if [ "$1" = 0 ]; then
  rm -f %{_bindir}/linux
fi

%files
%defattr(-,root,root)
%{_bindir}/linux-*
%{_libdir}/uml-*

%changelog
* Sun Feb 27 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.6.10-1m)
- version up (based on kernel-2.6.10-19m)

* Sun Dec 12 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.6.9-1m)
- new version
